#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <limits.h>

#define LINE_LEN 24

int main( void )
{
    unsigned int s;
    int j;
    char line[LINE_LEN],
         *ptr;

    int n_items = 0;

    do {
        n_items = 0;
        memset( line, '\0', sizeof(line) );
        fputs( "Enter hex value: ", stdout );
        fflush( stdout );
        if( NULL == fgets(line, sizeof(line), stdin) ) {
            fputs( "fgets() has a problem.\n", stderr );
            exit( EXIT_FAILURE );
        }
        if( NULL != (ptr = strchr(line, '\n')) ) *ptr = '\0';
        n_items = sscanf( line, "%x", &s );
    } while( n_items != 1 );

  
    fprintf( stdout, "Hex Value Entered: %#x\n", s );
    for( j = CHAR_BIT * sizeof(unsigned int) - 1; j >= 0; j-- ) {
         if( s & ( 1 << j) )
             printf( "%d", 1 );
         else
             printf( "%d", 0 );
         if( 0 == j % CHAR_BIT ) printf( " " );
         fflush( stdout );
    }
    puts( "\n" );

    exit( EXIT_SUCCESS );
}  
