/* My own linked list code */

#include <stdlib.h>
#include <stdio.h>

struct list {
       struct list *next;
       int data;
       };

void input_list( struct list *l_ptr )
{
   struct list *current;

   FILE *infile;
   char line[8];

   infile = fopen( "linked.dat", "r" );

/* Initialize the linked list */

   current = l_ptr;
   current->next = NULL;

   while( NULL != fgets(line, 8, infile) ) {
          sscanf( line, "%d", &(current->data) );
          current->next = malloc( sizeof(struct list) );
          current = current->next;

   }

   fclose( infile );
   return;
}

void print_list( struct list *l_ptr )
{
   struct list *current;

   current = l_ptr;

   while( NULL != current->next ) {
       printf( "%d\n", current->data );
       current = current->next;
   }

   return;
}

int main( void )
{
    struct list *first = malloc( sizeof(struct list) );

    input_list( first );
    print_list( first );

    exit( EXIT_SUCCESS );
}
