/* header file for SYSV IPC interface for cd4port */
#ifndef CD4PORT_IPC_H
#define CD4PORT_IPC_H
#define _XOPEN_SOURCE

#define CAD4_KEY  ((key_t)0xcad4d0)
#define MODE  (0666)         /* rw-rw-rw- */

/* sem_ipc.c */
extern int sem_set(int sem_id);
extern int sem_attempt_lock(int sem_id);
extern int sem_release(int sem_id);
extern int sem_delete(int sem_id) ;
#endif
