#include <stdio.h>
#include <stdlib.h>

void reverse_bytes( void *f, size_t size )
{
    int i, j;
    unsigned char *a = (unsigned char *)f;
    unsigned char tmp;

    j = size - 1;
    for( i = 0, j = size - 1; i < size / 2; i++, j-- ) {
       tmp = a[i];
       a[i] = a[j];
       a[j] = tmp;
   }
   return;
}

int main( void )
{
     int data = 12345;

     printf( "sizeof data = %d bytes\n", sizeof(data) );
     printf( "Initial string: %d\n", data );
     printf( "Initial string: %#x\n", data );
     reverse_bytes( &data, sizeof(data) );
     printf( "Reversed string: %#x\n", data );
     reverse_bytes( &data, sizeof(data) );
     printf( "Re-Reverse string: %#x\n", data );
     printf( "Re-reverse string: %d\n", data );


     exit( EXIT_SUCCESS );
}
